#!/usr/bin/env python
import sys, util, os
from qt import QMainWindow, QTextEdit, QApplication, QSizePolicy, QVBox, Qt, QPushButton, QPixmap

applic = QApplication(sys.argv)

win = QMainWindow()


box = QVBox(win)
box.show()

text_edit = QTextEdit(box)
text_edit.setTextFormat(Qt.PlainText)
text_edit.setWrapPolicy(QTextEdit.Anywhere)
text_edit.setWordWrap(QTextEdit.WidgetWidth)
text_edit.setReadOnly(True)
#text_edit.setMinimumSize(600,400)
text_edit.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)
text_edit.updateGeometry()

text_edit.show()

win.setCentralWidget(box)

close_button = QPushButton("You can safely close the window now", box)
close_button.setEnabled(False)
close_button.show()


i = util.find(range(0, len(sys.argv))
              , lambda x: sys.argv[x] =='-T')
title = sys.argv[i+1]
win.setCaption(title + " - output")

i = util.find(range(0, len(sys.argv))
              , lambda x: sys.argv[x] =='--pixmap')
if i!= None:
    pix = sys.argv[i+1]
    win.setIcon(QPixmap(pix))


i = util.find(range(0, len(sys.argv))
              , lambda x: sys.argv[x] =='--command')

f =   os.popen(sys.argv[i+1], 'r')
assert f
applic.setMainWidget(win)
win.showMaximized()


l = f.readline()
while l:
    text_edit.append(l)
    l = f.readline()
    applic.processEvents()

f.close()
win.setCaption("<Finished> " + title)
close_button.setEnabled(True)
applic.exec_loop()

